HDU 2795 Billboard 线段树 顺序点更新

来源:互联网 发布:由诲女知之乎翻译 编辑:程序博客网 时间:2024/06/07 15:02

原题: http://acm.hdu.edu.cn/showproblem.php?pid=2795

题目:

Billboard

Time Limit: 20000/8000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 15655 Accepted Submission(s): 6597

Problem Description
At the entrance to the university, there is a huge rectangular billboard of size h*w (h is its height and w is its width). The board is the place where all possible announcements are posted: nearest programming competitions, changes in the dining room menu, and other important information.

On September 1, the billboard was empty. One by one, the announcements started being put on the billboard.

Each announcement is a stripe of paper of unit height. More specifically, the i-th announcement is a rectangle of size 1 * wi.

When someone puts a new announcement on the billboard, she would always choose the topmost possible position for the announcement. Among all possible topmost positions she would always choose the leftmost one.

If there is no valid location for a new announcement, it is not put on the billboard (that’s why some programming contests have no participants from this university).

Given the sizes of the billboard and the announcements, your task is to find the numbers of rows in which the announcements are placed.

Input
There are multiple cases (no more than 40 cases).

The first line of the input file contains three integer numbers, h, w, and n (1 <= h,w <= 10^9; 1 <= n <= 200,000) - the dimensions of the billboard and the number of announcements.

Each of the next n lines contains an integer number wi (1 <= wi <= 10^9) - the width of i-th announcement.

Output
For each announcement (in the order they are given in the input file) output one number - the number of the row in which this announcement is placed. Rows are numbered from 1 to h, starting with the top row. If an announcement can’t be put on the billboard, output “-1” for this announcement.

Sample Input
3 5 5
2
4
3
3
3

Sample Output
1
2
1
3
-1

思路:

有规格为h*w的广告牌,有n个高度为1的广告牌,优先从高处放,从左边放,求每个广告牌放的位置,放不了输出-1。

这道题可以用线段树来做,把每排当作一个点,存放的是剩下的空间。
但是题目给的范围h、w是10^9,光是初始化就会超时。
细心我们会发现,广告牌最多有n个,即使每排只放一个,我们也用不到后面的线段,所以初始化的时候,当高度大于20W的时候,我们可以把只开20W的线段,小于就该多少开多少,这样就不会超时了。
剩下的就是一个简单的更新线段树了。

代码:

#include <iostream>#include"cstdio"#include"string.h"#include"stdlib.h"using namespace std;const int N = 200005;struct node{    int l;    int r;    int maxn;};node tree[N*4];int h,w,n;void build(int id,int l,int r){    tree[id].l=l;    tree[id].r=r;    tree[id].maxn=w;    if(l==r)    {        return;    }    else    {        int mid=(l+r)/2;        build(id*2,l,mid);        build(id*2+1,mid+1,r);    }}void update(int id,int val){    if(tree[id].l==tree[id].r)    {        tree[id].maxn=tree[id].maxn-val;        printf("%d\n",tree[id].l);        return ;    }   if(tree[id*2].maxn>=val) update(id*2,val);   else update(id*2+1,val);   tree[id].maxn=max(tree[id*2].maxn,tree[id*2+1].maxn);}int main(){    while(scanf("%d %d %d",&h,&w,&n)!=EOF)    {        build(1,1,min(h,N));        int p;        for(int i=1; i<=n; i++)        {            scanf("%d",&p);            if(p>tree[1].maxn)   printf("-1\n");            else update(1,p);        }    }    return 0;}
0 0
原创粉丝点击